Here is how to install RTcmix and its instrument packages.

If you have trouble, please join the rtcmix-discuss mailing list
<http://music.columbia.edu/mailman/listinfo/rtcmix-discuss>, and 
as for help.


1. Download RTcmix-[version].tar.gz and unpack it anywhere you like (in your
   home directory, or in /usr/local/src, for example) by typing

      tar xfz RTcmix-[version].tar.gz
      (or: gunzip -c RTcmix-[version].tar.gz | tar xf - )


2. Look in RTcmix-[version]/insts.  If it contains "base", "std", "jg", "stk"
   and "vccm" directories, then you can skip this step.  If you have only
   "base", then you need to download the instrument packages named above.
   Unpack them into the "insts" directory of your RTcmix.


3. cd into the top level of the RTcmix directory, and run the configure script:

      ./configure

   There are some options you might want to give this script.  Here's a
   description of them.  If you already ran configure without the options,
   it's okay to run it again with the options you want.
 
      --with-alsa       Use the ALSA driver, rather than OSS, on Linux
      --with-jack       Enable support for the JACK sound server
      --with-perl       Build the Perl-enabled RTcmix (PCMIX)
      --with-python     Build the Python-enabled RTcmix (PYCMIX)
      --with-netplay    Enable code that lets you play RTcmix over a network
      --with-fftw       Use the FFTW3 library, instead of the builtin FFT code
      --with-osc        Compile support for receiving OSC (Open Sound Control)

   If you have more than one version of Perl or Python on your system, you
   can tell RTcmix which one to use by giving its path with the option, e.g.:

      --with-python=/usr/local/bin/python

   Give these options in any order, following the configure script name:

      ./configure --with-alsa --with-perl --with-python

   NOTE: If you're running a Mac OS X earlier than 10.3 and want to enable
   Python, see the instructions below.

   For additional configure options, run "./configure --help".  Some of the
   standard GNU options are not yet enabled for RTcmix.

   If you want to use the optional FFTW (Fastest Fourier Transform in the West)
   support, you must install the fftw3f library that is part of the fftw
   package (see fftw.org).  Configure this package with "--enable-float"
   before making and installing.  Configure RTcmix with "--with-fftw".

   If you want to use the optional OSC (Open Sound Control) support, you must
   install the liblo library <http://plugin.org.uk/liblo>.  On OS X, configure
   this library with "--disable-ipv6".

   To build RTcmix with FFTW, Jack or liblo support, you must have the pkgconfig
   package installed.  Any recent Linux distribution has this, but OS X doesn't.
   Get it from Fink or DarwinPorts, or compile it from source:
   <http://pkgconfig.freedesktop.org/releases/pkg-config-0.20.tar.gz>.


4. There are some special settings that you can make in the "site.conf" file,
   though most people will never need to do this.


5. Make the package.  Be sure you're still in the top RTcmix directory and type:

      make


6. If the package builds without errors, install it:

      make install


7. Add the bin directory inside of the RTcmix directory to your $PATH.  For
   example, if you're using the bash shell, put something like this in .profile:

      PATH="/path/to/rtcmix/bin:$PATH"
      export PATH


8. Try running some of the scores in docs/sample_scores.  To run any score,
   type "CMIX < scorefile.sco".  If these seem to work, your installation
   is probably ok.


See the README files in the docs dir for information on recent features.

For some help getting started, check out the documentation and tutorials
at rtcmix.org.


--------------------------------------------------------------------------------
Platform Notes


Linux
-----


Mac OS X
--------

   - You must use OS X 10.1 or later, and you must have installed the
     appropriate version of the Developer Tools.

   - If you want to use gnuplot with the fplot and plottable script functions,
     you have to install both the command-line gnuplot and the Aquaterm program.

     First download the Aquaterm v1.0.b2 (or later) binary package (.dmg) from
     http://aquaterm.sourceforge.net, and install the package.  (NB: I had
     trouble getting v1.0.0 to work; v1.0.b2 did work.)

     Then install gnuplot.  You can build this from source (v. 4.0 or later),
     but the easiest way is to download the binary package (currently called
     "Gnuplot-4.0.0.dmg") from http://gnuplot.sourceforge.net.

     If you want to install gnuplot from source, grab "gnuplot-4.0.0.tar.gz"
     from ftp.gnuplot.info and unpack this in /usr/local/src.  Build the
     package like this:

        ./configure --without-x
        make
        sudo make install

     Another alternative, esp. if you have fink installed, is to type...

        fink install gnuplot

     You'll probably have to add /usr/local/bin to your shell path.  For bash,
     do something like this in .profile:

        PATH=/usr/local/bin:${PATH}
        export PATH

   - If you want to enable the Python front end, and you are running a version
     of Mac OS X earlier than 10.3, you will have to build Python from source,
     because the Python supplied with the Developer Tools CD is incomplete.
     See the instructions in RTcmix/src/parser/python/NOTES.


SGI Irix
--------

   - It's been a long time since any of us have compiled RTcmix on Irix, so
     who knows whether it will work or even build.  Let us know what you find.



-JGG, 8/1/04; rev. for v4, 6/17/05

